---
title: Nextcloud example
weight: 3
---

Heard about [Nextcloud](https://nextcloud.com/)? Let's say that we want to deploy a Nextcloud instance for a nice association fighting marketing.

Before deploying the Nextcloud, we'll need to list the backing services that would be necessary:

 - postgres database
 - redis cache
 - smtp relay to send email notifications
 - S3 compatible API for object store
 - OpenIdConnect provider for Single Sign On
 - libre office online

This is to deploy a reliable and scalable Nextcloud instance. For the sake of simplicity, let's say that we just need Postgres. But keep in mind, that we have the other backing services in mind too, and that we can use the same paradigms.

We'll assume for the rest of the example that you already got a kubernetes cluster running.

The domain name of the association is `fight.marketing`. You already created a namespace `fight-marketing` and added the annotation `domaine-name: fight.marketing`.

Let's now see how we solve our problem with the [kubernetes operators](/kubernetesoperators/).